!
!   Copyright (C) 2007 by Pasquale Londrillo & Carlo Nipoti               
!   pasquale.londrillo@oabo.inaf.it   carlo.nipoti@unibo.it   
!                                                                         
!   This program is free software; you can redistribute it and/or modify  
!   it under the terms of the GNU General Public License 
!                                                                         
!   This program is distributed in the hope that it will be useful,       
!   but WITHOUT ANY WARRANTY; without even the implied warranty of        
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         
!   GNU General Public License for more details.                          
!  
!   Indications of bugs identification and suggestions on possible 
!   improvement are welcome.  
! 

 module struct
 type::  particle
  real(kind=4) :: posvel(6)
 end type particle  
end module struct

module parallel
  use struct
!  include 'mpif.h'

  integer :: partype

  integer :: mype,npe,pe_min,pe_max,pe_h,npe_h,kd

  integer,allocatable  :: pe_next(:),pe_prev(:)
  real,allocatable :: sbuff(:,:,:),lbdth(:,:,:),rbdth(:,:,:)

  integer,allocatable,dimension(:,:):: pe_ind

  integer,allocatable,dimension(:):: nbd

  integer :: nbd_max,nbd_min

  logical :: pe0,prl

 contains

 subroutine start_parallel
    integer:: k,ipe,ik2,k_h,k_hh



    pe0=.true.
    prl=.false.

    npe=1
    pe_min=0
    pe_max=0
    npe_h=npe/2
    pe_h=npe_h-1
    mype=0

    k=kind(1.0)
  


   allocate(nbd(0:pe_max))

  end subroutine start_parallel
!
  subroutine end_parallel

    return

  end subroutine end_parallel

  subroutine exchange_grdata(sr,dat0,n1,n2,n3,ipe,tag)
   integer,intent(in) :: n1,n2,n3,ipe,tag
   real,intent(inout) :: dat0(:,:,:)
   logical,intent(in) :: sr
   integer :: lenw

   return


  end subroutine exchange_grdata

  subroutine exchange_thbd_data(dat0,n1,n2,n3,npt)
   integer,intent(in) :: n1,n2,n3,npt
   real,intent(in) :: dat0(0:n1,0:n2-1,0:n3-1)
   integer :: k,j,j1,lenw,ip,tag,spe,rpe

   return

  end subroutine exchange_thbd_data

  subroutine fill_grdata(dat0,aux1,aux2,n1,n2t,n2,n3)
   integer,intent(in) :: n1,n2t,n2,n3
   real,intent(in) :: aux1(n1+1,n2,n3)
   real,intent(inout) :: dat0(0:n1,0:n2t-1,0:n3-1)
   real :: aux2(n1+1,n2,n3)
   integer :: k,j1,j,lenw,ip,tag,spe,rpe

   return

  end subroutine fill_grdata

  subroutine intvec_dist(nc)

   integer :: nc(0:pe_max)
   integer :: ipe

   return

  end subroutine intvec_dist

  subroutine exchange_pdata(sr,dat0,lenw,ipe,tag)
   integer,intent(in) :: lenw,ipe,tag
   logical,intent(in) :: sr

   type(particle),intent(inout) :: dat0(lenw)

   return

  end subroutine exchange_pdata

  subroutine exchange_rdata(sr,dat0,lenw,ipe,tag)
   integer,intent(in) :: lenw,ipe,tag
   logical,intent(in) :: sr

   real,intent(inout) :: dat0(lenw)

   return

  end subroutine exchange_rdata

  subroutine exchange_idata(sr,dat0,lenw,ipe,tag)
   integer,intent(in) :: lenw,ipe,tag
   logical,intent(in) :: sr

   integer,intent(inout) :: dat0(lenw)

   return

  end subroutine exchange_idata
! ***************************************************************************
  subroutine allreduce_real_sdata(dt_prl,dt,ib)

   integer,intent(in) :: ib
   real :: dt_prl
   real :: dt
   integer,parameter :: nt=1

    dt=dt_prl

  end subroutine allreduce_real_sdata 
  subroutine allreduce_real_data(nt,dt_prl,dt,ib)

   integer,intent(in) :: ib,nt
   real :: dt_prl(nt)
   real :: dt(nt)


    dt=dt_prl


  end subroutine allreduce_real_data 

  subroutine bcast_real_data(nt,dt)

   integer,intent(in) :: nt
   real :: dt(nt)

   return

  end subroutine bcast_real_data

  subroutine allreduce_int_sdata(dt_prl,dt,mp_mode)

   integer,intent(in) :: mp_mode
   integer :: dt_prl
   integer :: dt
   integer,parameter :: nt=1

    dt=dt_prl

  end subroutine allreduce_int_sdata

 subroutine bcast_int_data(nt,dt)

  integer,intent(in) :: nt
  integer :: dt(nt)

  return

 end subroutine bcast_int_data
!=======================
 subroutine allreduce_int_data(nt,dt_prl,dt,mp_mode)

   integer,intent(in) :: mp_mode,nt
   integer :: dt_prl(nt)
   integer :: dt(nt)

    dt=dt_prl

  end subroutine allreduce_int_data

  subroutine sumreduce_grdata(ib,dat0,dat1,n1,n2,n3)
   logical,intent(in) :: ib
   integer,intent(in) :: n1,n2,n3
   real,intent(in) :: dat0(n1,n2,n3) 
   real,intent(out) :: dat1(n1,n2,n3) 
   integer :: lenw

   dat1=dat0
   return

  end subroutine sumreduce_grdata
!----------------------------------
 end module parallel
